#include <iostream>

#include "CifLoadReorganizer.h"


int main(int argc, char ** argv)
{
  if (argc != 3)
  {
    cerr << "Usage: " << argv[0] 
	 << " <object filename> <datablock name>" << endl;
    exit(0);
  }

  DictFileCont dictFileCont(argv[1]);

  dictFileCont.Read();

  dictFileCont.SetCurrentDictionary(argv[2]);

  cout << "Get everthing ... individually ..." << endl << endl;

  DdlDictCont* ddlDictContP = dictFileCont.GetCurrDictCont();

  vector<string> title;
  ddlDictContP->GetDdlItem(title, DdlContInfo::CIF_DDL_CATEGORY_DICTIONARY,
    DdlContInfo::CIF_DDL_ITEM_TITLE);

  vector<string> version;
  ddlDictContP->GetDdlItem(version, DdlContInfo::CIF_DDL_CATEGORY_DICTIONARY,
    DdlContInfo::CIF_DDL_ITEM_VERSION);

  vector<string> description;
  ddlDictContP->GetDdlItem(description, DdlContInfo::CIF_DDL_CATEGORY_DATABLOCK,
    DdlContInfo::CIF_DDL_ITEM_DESCRIPTION);


  vector<string> historyVersion;
  ddlDictContP->GetDdlItem(historyVersion,
    DdlContInfo::CIF_DDL_CATEGORY_DICTIONARY_HISTORY, DdlContInfo::CIF_DDL_ITEM_VERSION);

  vector<string> historyUpdate;
  ddlDictContP->GetDdlItem(historyUpdate,
    DdlContInfo::CIF_DDL_CATEGORY_DICTIONARY_HISTORY, DdlContInfo::CIF_DDL_ITEM_UPDATE);

  vector<string> historyRevision;
  ddlDictContP->GetDdlItem(historyRevision,
    DdlContInfo::CIF_DDL_CATEGORY_DICTIONARY_HISTORY, DdlContInfo::CIF_DDL_ITEM_REVISION);

  vector<string> subcategories;
  ddlDictContP->GetDdlItem(subcategories, DdlContInfo::CIF_DDL_CATEGORY_SUB_CATEGORY,
    DdlContInfo::CIF_DDL_ITEM_ID);

  vector<string> categories;
  ddlDictContP->GetDdlItem(categories, DdlContInfo::CIF_DDL_CATEGORY_CATEGORY,
    DdlContInfo::CIF_DDL_ITEM_ID);

  vector<string> items;
  ddlDictContP->GetDdlItem(items, DdlContInfo::CIF_DDL_CATEGORY_ITEM, DdlContInfo::CIF_DDL_ITEM_NAME);

  vector<string> methods;
  ddlDictContP->GetDdlItem(methods, DdlContInfo::CIF_DDL_CATEGORY_DATABLOCK_METHODS,
    DdlContInfo::CIF_DDL_ITEM_DATABLOCK_ID);

  vector<string> methodsId;
  ddlDictContP->GetDdlItem(methodsId, DdlContInfo::CIF_DDL_CATEGORY_DATABLOCK_METHODS,
    DdlContInfo::CIF_DDL_ITEM_METHOD_ID);

  vector<string> methodsList;
  ddlDictContP->GetDdlItem(methodsList, DdlContInfo::CIF_DDL_CATEGORY_METHOD_LIST,
    DdlContInfo::CIF_DDL_ITEM_ID);

  vector<string> methodsListDetail;
  ddlDictContP->GetDdlItem(methodsListDetail, DdlContInfo::CIF_DDL_CATEGORY_METHOD_LIST,
    DdlContInfo::CIF_DDL_ITEM_DETAIL);

  vector<string> methodsListInline;
  ddlDictContP->GetDdlItem(methodsListInline, DdlContInfo::CIF_DDL_CATEGORY_METHOD_LIST,
    DdlContInfo::CIF_DDL_ITEM_INLINE);

  vector<string> methodsListCode;
  ddlDictContP->GetDdlItem(methodsListCode, DdlContInfo::CIF_DDL_CATEGORY_METHOD_LIST,
    DdlContInfo::CIF_DDL_ITEM_CODE);

  vector<string> methodsListLanguage;
  ddlDictContP->GetDdlItem(methodsListLanguage,
    DdlContInfo::CIF_DDL_CATEGORY_METHOD_LIST, DdlContInfo::CIF_DDL_ITEM_LANGUAGE);

  vector<string> categoryGroupList;
  ddlDictContP->GetDdlItem(categoryGroupList,
    DdlContInfo::CIF_DDL_CATEGORY_CATEGORY_GROUP_LIST, DdlContInfo::CIF_DDL_ITEM_ID);

  vector<string> categoryGroupListParents;
  ddlDictContP->GetDdlItem(categoryGroupListParents,
    DdlContInfo::CIF_DDL_CATEGORY_CATEGORY_GROUP_LIST, DdlContInfo::CIF_DDL_ITEM_PARENT_ID);

  vector<string> categoryGroupListDescription;
  ddlDictContP->GetDdlItem(categoryGroupListDescription,
    DdlContInfo::CIF_DDL_CATEGORY_CATEGORY_GROUP_LIST, DdlContInfo::CIF_DDL_ITEM_DESCRIPTION);

  vector<string> itemStructureListCode;
  ddlDictContP->GetDdlItem(itemStructureListCode,
    DdlContInfo::CIF_DDL_CATEGORY_ITEM_STRUCTURE_LIST, DdlContInfo::CIF_DDL_ITEM_CODE);

  vector<string> itemStructureListIndex;
  ddlDictContP->GetDdlItem(itemStructureListIndex,
    DdlContInfo::CIF_DDL_CATEGORY_ITEM_STRUCTURE_LIST, DdlContInfo::CIF_DDL_ITEM_INDEX);

  vector<string> itemStructureListDimension;
  ddlDictContP->GetDdlItem(itemStructureListDimension,
    DdlContInfo::CIF_DDL_CATEGORY_ITEM_STRUCTURE_LIST, DdlContInfo::CIF_DDL_ITEM_DIMENSION);

  vector<string> itemTypeListCode;
  ddlDictContP->GetDdlItem(itemTypeListCode,
    DdlContInfo::CIF_DDL_CATEGORY_ITEM_TYPE_LIST, DdlContInfo::CIF_DDL_ITEM_CODE);

  vector<string> itemTypeListPrimitiveCode;
  ddlDictContP->GetDdlItem(itemTypeListPrimitiveCode,
    DdlContInfo::CIF_DDL_CATEGORY_ITEM_TYPE_LIST, DdlContInfo::CIF_DDL_ITEM_PRIMITIVE_CODE);

  vector<string> itemTypeListConstruct;
  ddlDictContP->GetDdlItem(itemTypeListConstruct,
    DdlContInfo::CIF_DDL_CATEGORY_ITEM_TYPE_LIST, DdlContInfo::CIF_DDL_ITEM_CONSTRUCT);

  vector<string> itemTypeListDetail;
  ddlDictContP->GetDdlItem(itemTypeListDetail,
    DdlContInfo::CIF_DDL_CATEGORY_ITEM_TYPE_LIST, DdlContInfo::CIF_DDL_ITEM_DETAIL);

  vector<string> itemUnitsListCode;
  ddlDictContP->GetDdlItem(itemUnitsListCode,
    DdlContInfo::CIF_DDL_CATEGORY_ITEM_UNITS_LIST, DdlContInfo::CIF_DDL_ITEM_CODE);

  vector<string> itemUnitsListDetail;
  ddlDictContP->GetDdlItem(itemUnitsListDetail,
    DdlContInfo::CIF_DDL_CATEGORY_ITEM_UNITS_LIST, DdlContInfo::CIF_DDL_ITEM_DETAIL);

  vector<string> itemUnitsConversionOperator;
  ddlDictContP->GetDdlItem(itemUnitsConversionOperator,
    DdlContInfo::CIF_DDL_CATEGORY_ITEM_UNITS_CONVERSION, DdlContInfo::CIF_DDL_ITEM_OPERATOR);

  vector<string> itemUnitsConversionFactor;
  ddlDictContP->GetDdlItem(itemUnitsConversionFactor,
    DdlContInfo::CIF_DDL_CATEGORY_ITEM_UNITS_CONVERSION, DdlContInfo::CIF_DDL_ITEM_FACTOR);

  vector<string> itemUnitsConversionFromCode;
  ddlDictContP->GetDdlItem(itemUnitsConversionFromCode,
    DdlContInfo::CIF_DDL_CATEGORY_ITEM_UNITS_CONVERSION, DdlContInfo::CIF_DDL_ITEM_FROM_CODE);

  vector<string> itemUnitsConversionToCode;
  ddlDictContP->GetDdlItem(itemUnitsConversionToCode,
    DdlContInfo::CIF_DDL_CATEGORY_ITEM_UNITS_CONVERSION, DdlContInfo::CIF_DDL_ITEM_TO_CODE);

  DdlCont* itemContP = NULL;

  vector<string> tmp;
  vector<string> regexes;
  for (uWord a = 0; a < items.size(); a++)
  {
    itemContP = ddlDictContP->GetDdlCont(items[a], RcsbDdlItem);

    tmp.clear();

    itemContP->GetDdlItem(tmp, DdlContInfo::CIF_DDL_CATEGORY_ITEM_TYPE_LIST,
      DdlContInfo::CIF_DDL_ITEM_CONSTRUCT);

    regexes.push_back(tmp[0]);
    if (regexes[a].empty())
    {
        cout << a << ": " << "(null)" << endl;
    }
    else
    {
        cout << a << ": " << regexes[a] << endl;
    }
  }

#ifdef VLAD_DELETED
  string title = dictFileCont.GetDictionaryTitle();
  string version = dictFileCont.GetDictionaryVersion(); 
  string description = dictFileCont.GetDictionaryDescription();

  vector<string> historyVersion;
  dictFileCont.GetDictionaryHistoryVersion(historyVersion);
  vector<string> historyUpdate;
  dictFileCont.GetDictionaryHistoryUpdate(historyUpdate);
  vector<string> historyRevision;
  dictFileCont.GetDictionaryHistoryRevision(historyRevision);
  vector<string> subcategories;
  dictFileCont.GetDictionarySubcategories(subcategories);
  vector<string> categories;
  dictFileCont.GetDictionaryCategories(categories);
  vector<string> items;
  dictFileCont.GetDictionaryItems(items);
  vector<string> methods;
  dictFileCont.GetDictionaryMethods(methods);
  vector<string> methodsId;
  dictFileCont.GetDictionaryMethodsId(methodsId);
  vector<string> methodsList;
  dictFileCont.GetDictionaryMethodsList(methodsList);
  vector<string> methodsListDetail;
  dictFileCont.GetDictionaryMethodsListDetail(methodsListDetail);
  vector<string> methodsListInline;
  dictFileCont.GetDictionaryMethodsListInline(methodsListInline);
  vector<string> methodsListCode;
  dictFileCont.GetDictionaryMethodsListCode(methodsListCode);
  vector<string> methodsListLanguage;
  dictFileCont.GetDictionaryMethodsListLanguage(methodsListLanguage);
  vector<string> categoryGroupList;
  dictFileCont.GetDictionaryCategoryGroupList(categoryGroupList);
  vector<string> categoryGroupListParents;
  dictFileCont.GetDictionaryCategoryGroupListParents(categoryGroupListParents);
  vector<string> categoryGroupListDescription;
  dictFileCont.GetDictionaryCategoryGroupListDescription(categoryGroupListDescription);
  vector<string> itemStructureListCode;
  dictFileCont.GetDictionaryItemStructureListCode(itemStructureListCode);
  vector<string> itemStructureListIndex;
  dictFileCont.GetDictionaryItemStructureListIndex(itemStructureListIndex);
  vector<string> itemStructureListDimension;
  dictFileCont.GetDictionaryItemStructureListDimension(itemStructureListDimension);
  vector<string> itemTypeListCode;
  dictFileCont.GetDictionaryItemTypeListCode(itemTypeListCode);
  vector<string> itemTypeListPrimitiveCode;
  dictFileCont.GetDictionaryItemTypeListPrimitiveCode(itemTypeListPrimitiveCode);
  vector<string> itemTypeListConstruct;
  dictFileCont.GetDictionaryItemTypeListConstruct(itemTypeListConstruct);
  vector<string> itemTypeListDetail;
  dictFileCont.GetDictionaryItemTypeListDetail(itemTypeListDetail);
  vector<string> itemUnitsListCode;
  dictFileCont.GetDictionaryItemUnitsListCode(itemUnitsListCode);
  vector<string> itemUnitsListDetail;
  dictFileCont.GetDictionaryItemUnitsListDetail(itemUnitsListDetail);
  vector<string> itemUnitsConversionOperator;
  dictFileCont.GetDictionaryItemUnitsConversionOperator(itemUnitsConversionOperator);
  vector<string> itemUnitsConversionFactor;
  dictFileCont.GetDictionaryItemUnitsConversionFactor(itemUnitsConversionFactor);
  vector<string> itemUnitsConversionFromCode;
  dictFileCont.GetDictionaryItemUnitsConversionFromCode(itemUnitsConversionFromCode);
  vector<string> itemUnitsConversionToCode;
  dictFileCont.GetDictionaryItemUnitsConversionToCode(itemUnitsConversionToCode);

  uWord b = items.size();
  vector<string> regexes;
  for (uWord a = 0; a < b; a++) {
    regexes.push_back(dictFileCont.GetItemRegex(items[a].c_str()));
    if (regexes[a].empty())
    {
        cout << a << ": " << "(null)" << endl;
    }
    else
    {
        cout << a << ": " << regexes[a] << endl;
    }
  }
#endif

  uWord i;
  cout << "Title: " << title[0] << endl;
  cout << "Version: " << version[0] << endl;
  if (description[0].empty())
  {
      cout << "Description: " << "(null)" << endl;
  }
  else
  {
      cout << "Description: " << description[0] << endl;
  }
  cout << "HistoryVersion: (" << historyVersion.size() << ")" << endl;
  for (i = 0; i < historyVersion.size(); i++) {
    cout << "  #" << i << " : " << historyVersion[i] << endl;
    historyVersion[i].clear();
  }
  historyVersion.clear();
  cout << "HistoryUpdate: (" << historyUpdate.size() << ")" << endl;
  for (i = 0; i < historyUpdate.size(); i++) { 
    cout << "  #" << i << " : " << historyUpdate[i] << endl;
    historyUpdate[i].clear();
  }
  historyUpdate.clear();
  cout << "HistoryRevision: (" << historyRevision.size() << ")" << endl;
  for (i = 0; i < historyRevision.size(); i++) {
    cout << "  #" << i << " : " << historyRevision[i] << endl;
    historyRevision[i].clear();
  }
  historyRevision.clear();

  cout << "Categories: (" << categories.size() << ")" << endl;
  for (i = 0; i < categories.size(); i++) {
    cout << "  #" << i << " : " << categories[i] << endl;
    categories[i].clear();
  }
  categories.clear();
  cout << "SubCategories: (" << subcategories.size() << ")" << endl;
  for (i = 0; i < subcategories.size(); i++) {
    cout << "  #" << i << " : " << subcategories[i] << endl;
    subcategories[i].clear();
  }
  subcategories.clear();
  cout << "Items: (" << items.size() << ")" << endl;
  for (i = 0; i < items.size(); i++) {
    cout << "  #" << i << " : " << items[i] << endl;
    items[i].clear();
  }
  items.clear();
  cout << "MethodsDB: (" << methods.size() << ")" << endl;
  for (i = 0; i < methods.size(); i++)
    cout << "  #" << i << " : " << methods[i] << endl;
  cout << "MethodsID: (" << methodsId.size() << ")" << endl;
  for (i = 0; i < methodsId.size(); i++)
    cout << "  #" << i << " : " << methodsId[i] << endl;
  cout << "MethodsList: (" << methodsList.size() << ")" << endl;
  for (i = 0; i < methodsList.size(); i++)
    cout << "  #" << i << " : " << methodsList[i] << endl;
  cout << "MethodsListDetail: (" << methodsListDetail.size() << ")" << endl;
  for (i = 0; i < methodsListDetail.size(); i++)
    cout << "  #" << i << " : " << methodsListDetail[i] << endl;
  cout << "MethodsListInline: (" << methodsListInline.size() << ")" << endl;
  for (i = 0; i < methodsListInline.size(); i++)
    cout << "  #" << i << " : " << methodsListInline[i] << endl;
  cout << "MethodsListCode: (" << methodsListCode.size() << ")" << endl;
  for (i = 0; i < methodsListCode.size(); i++)
    cout << "  #" << i << " : " << methodsListCode[i] << endl;
  cout << "MethodsListLanguage: (" << methodsListLanguage.size() << ")" << endl;
  for (i = 0; i < methodsListLanguage.size(); i++)
    cout << "  #" << i << " : " << methodsListLanguage[i] << endl;

  cout << "CategoryGroupList: (" << categoryGroupList.size() << ")" << endl;
  for (i = 0; i < categoryGroupList.size(); i++)
    cout << "  #" << i << " : " << categoryGroupList[i] << endl;

  cout << "CategoryGroupListParents: (" << categoryGroupListParents.size() << ")" << endl;
  for (i = 0; i < categoryGroupListParents.size(); i++)
    cout << "  #" << i << " : " << categoryGroupListParents[i] << endl;

  cout << "CategoryGroupListDescription: (" << categoryGroupListDescription.size() << ")" << endl;
  for (i = 0; i < categoryGroupListDescription.size(); i++)
    cout << "  #" << i << " : " << categoryGroupListDescription[i] << endl;

  cout << "ItemStructureListCode: (" << itemStructureListCode.size() << ")" << endl;
  for (i = 0; i < itemStructureListCode.size(); i++)
    cout << "  #" << i << " : " << itemStructureListCode[i] << endl;
  cout << "ItemStructureListIndex: (" << itemStructureListIndex.size() << ")" << endl;
  for (i = 0; i < itemStructureListIndex.size(); i++)
    cout << "  #" << i << " : " << itemStructureListIndex[i] << endl;
  cout << "ItemStructureListDimension: (" << itemStructureListDimension.size() << ")" << endl;
  for (i = 0; i < itemStructureListDimension.size(); i++)
    cout << "  #" << i << " : " << itemStructureListDimension[i] << endl;

  cout << "ItemTypeListCode: (" << itemTypeListCode.size() << ")" << endl;
  for (i = 0; i < itemTypeListCode.size(); i++)
    cout << "  #" << i << " : " << itemTypeListCode[i] << endl;
  cout << "ItemTypeListPrimitiveCode: (" << itemTypeListPrimitiveCode.size() << ")" << endl;
  for (i = 0; i < itemTypeListPrimitiveCode.size(); i++)
    cout << "  #" << i << " : " << itemTypeListPrimitiveCode[i] << endl;
  cout << "ItemTypeListConstruct: (" << itemTypeListConstruct.size() << ")" << endl;
  for (i = 0; i < itemTypeListConstruct.size(); i++)
    cout << "  #" << i << " : " << itemTypeListConstruct[i] << endl;
  cout << "ItemTypeListDetail: (" << itemTypeListDetail.size() << ")" << endl;
  for (i = 0; i < itemTypeListDetail.size(); i++)
    cout << "  #" << i << " : " << itemTypeListDetail[i] << endl;

  cout << "ItemUnitsListCode: (" << itemUnitsListCode.size() << ")" << endl;
  for (i = 0; i < itemUnitsListCode.size(); i++)
    cout << "  #" << i << " : " << itemUnitsListCode[i] << endl;
  cout << "ItemUnitsListDetail: (" << itemUnitsListDetail.size() << ")" << endl;
  for (i = 0; i < itemUnitsListDetail.size(); i++)
    cout << "  #" << i << " : " << itemUnitsListDetail[i] << endl;

  cout << "ItemUnitsConversionOperator: (" << itemUnitsConversionOperator.size() << ")" << endl;
  for (i = 0; i < itemUnitsConversionOperator.size(); i++)
    cout << "  #" << i << " : " << itemUnitsConversionOperator[i] << endl;
  cout << "ItemUnitsConversionFactor: (" << itemUnitsConversionFactor.size() << ")" << endl;
  if (!itemUnitsConversionFactor.empty())
    for (i = 0; i < itemUnitsConversionFactor.size(); i++)
      if (!itemUnitsConversionFactor[i].empty())
        cout << "  #" << i << " : " << itemUnitsConversionFactor[i] << endl;

  cout << "ItemUnitsConversionFromCode: (" << itemUnitsConversionFromCode.size() << ")" << endl;
   if (!itemUnitsConversionFromCode.empty())
     for (i = 0; i < itemUnitsConversionFromCode.size(); i++)
      if (!itemUnitsConversionFromCode[i].empty())
        cout << "  #" << i << " : " << itemUnitsConversionFromCode[i] << endl;

  cout << "ItemUnitsConversionToCode: (" << itemUnitsConversionToCode.size() << ")" << endl;
   if (!itemUnitsConversionToCode.empty())
     for (i = 0; i < itemUnitsConversionToCode.size(); i++)
      if (!itemUnitsConversionToCode[i].empty())
        cout << "  #" << i << " : " << itemUnitsConversionToCode[i] << endl;


  cout << "Done!" << endl;

  exit(0);
}

